Package: methyLImp2
Title: Missing value estimation of DNA methylation data
Version: 1.9.0
Authors@R: c(
    person("Pietro", "Di Lena", 
    role = c("aut"),
    comment = c(ORCID = "0000-0002-1838-8918")),
    person("Anna", "Plaksienko", 
    email = "anna@plaxienko.com", 
    role = c("aut", "cre"),
    comment = c(ORCID = "0000-0001-9607-057X")),
    person("Claudia", "Angelini", 
    role = c("aut"),
    comment = c(ORCID = "0000-0001-8350-8464")),
    person("Christine", "Nardini", 
    role = c("aut"),
    comment = c(ORCID = "0000-0001-7601-321X")))  
Description: This package allows to estimate missing values in DNA methylation data. methyLImp method is based on linear regression since methylation levels show a high degree of inter-sample correlation. Implementation is parallelised over chromosomes since probes on different chromosomes are usually independent. Mini-batch approach to reduce the runtime in case of large number of samples is available.
Imports: BiocParallel, parallel, stats, methods, corpcor,
        SummarizedExperiment, utils
Depends: R (>= 4.3.0), ChAMPdata
URL: https://github.com/annaplaksienko/methyLImp2
BugReports: https://github.com/annaplaksienko/methyLImp2/issues
License: GPL-3
Encoding: UTF-8
RoxygenNote: 7.3.3
biocViews: DNAMethylation, Microarray, Software, MethylationArray,
        Regression
Suggests: BiocStyle, knitr, rmarkdown, spelling, testthat (>= 3.0.0)
VignetteBuilder: knitr
Config/testthat/edition: 3
Language: en-US
git_url: https://git.bioconductor.org/packages/methyLImp2
git_branch: devel
git_last_commit: d5bec10
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 23:43:03 UTC; biocbuild
Author: Pietro Di Lena [aut] (ORCID: <https://orcid.org/0000-0002-1838-8918>),
  Anna Plaksienko [aut, cre] (ORCID:
    <https://orcid.org/0000-0001-9607-057X>),
  Claudia Angelini [aut] (ORCID: <https://orcid.org/0000-0001-8350-8464>),
  Christine Nardini [aut] (ORCID:
    <https://orcid.org/0000-0001-7601-321X>)
Maintainer: Anna Plaksienko <anna@plaxienko.com>

# methyLImp2
**methyLImp2** package is the implementation of the updated version of the _methyLImp_ method for missing value imputation in methylation data. Compared to the previous version, implementation is parallelised over chromosomes since probes on different chromosomes are usually independent. Moreover, mini-batch approach to reduce the runtime in case of large number of samples is available.

## Installation

Package is available from [Bioconductor](https://www.bioconductor.org/packages/release/bioc/html/methyLImp2.html)! To install, run
```
if (!require("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("methyLImp2")
```

To install from Github, run
```
#install.packages("devtools")

library("devtools")
install_github("annaplaksienko/methyLImp2", build_vignettes = TRUE)
```

## Vignette
To open the vignette, run

```{r run methyLImp}
library(methyLImp2)
browseVignettes("methyLImp2")
```

#' Extract a vector of beta values of interest out of a matrix, 
#' given the positions of artificial NAs
#'
#' @param beta numeric data matrix
#' @param na_positions a list where each element is a list of two elements: 
#' column id and ids of rows with NAs in that column (structure matches the 
#' output of generateMissingData function). We need this because some NAs in 
#' the dataset are from real data and not artificial, so we can't evaluate the 
#' performance of the method on them since we do not know real value. 
#' Therefore, we need to know the positions of artificial NAs. 
#' 
#' @return A numerical vector of beta values
#'
#' @keywords internal
#' @noRd

extract_values <- function(beta, na_positions) {
    
    nna <- length(na_positions)
    
    beta_vector <- c()
    
    for (l in seq_len(nna)) {
        col <- na_positions[[l]]$na_col
        rows <- na_positions[[l]]$na_rows 
        
        curr_values <- beta[rows, col]
        beta_vector <- c(beta_vector, curr_values)
    }
    
    names(beta_vector) <- NULL
    
    return(beta_vector)
}

#' Evaluate performance metrics: root mean square error (RMSE), 
#' mean absolute error (MAE), mean absolute percentage error (MAPE) and
#' Pearson correlation coefficient (PCC).
#'
#' This function computes performance metrics as an element-wise difference 
#' between two matrices (skipping NA elements that were not imputed): 
#' * \eqn{RMSE = \sqrt{\sum_i (true_i - est_i)^2 / \#NAs)}};
#' * \eqn{MAE = \sum_i |true_i - est_i| / \#NAs};
#' * \eqn{MAPE = \dfrac{100}{n} \sum_i |true_i - est_i / true_i|} 
#' (here we omit the true beta-values equal to 0 and their  predicted values
#' to  avoid an indeterminate measure);
#' * \eqn{PCC = \dfrac{\sum_i (true_i - \bar{true_i}) \sum_i(est_i - \bar{est}_i)}{\sqrt{\sum_i (true_i - \bar{true}_i)^2}} \sqrt{\sum_i(est_i - \bar{est_i})^2}}.
#'
#' @param beta_true first numeric data matrix.
#' @param beta_imputed second numeric data matrix
#' @param na_positions a list where each element is a list of two elements: 
#' column id and ids of rows with NAs in that column (structure matches the 
#' output of generateMissingData function). We need this because some NAs in 
#' the dataset are from real data and not artificial, so we can't evaluate the 
#' performance of the method on them since we do not know real value. 
#' Therefore, we need to know the positions of artificial NAs. 
#' 
#' @return A numerical vector of four numbers: root mean square error (RMSE), 
#' mean absolute error (MAE), mean absolute percentage error (MAPE) and
#' Pearson correlation coefficient (PCC).
#'
#' @importFrom stats cor
#' 
#' @export
#' 
#' @examples
#' data(beta)
#' with_missing_data <- generateMissingData(beta, lambda = 3.5)
#' beta_with_nas <- with_missing_data$beta_with_nas
#' na_positions <- with_missing_data$na_positions
#' beta_imputed <- methyLImp2(input = beta_with_nas, type = "EPIC", 
#'                           minibatch_frac = 0.5,
#'                           BPPARAM = BiocParallel::SnowParam(workers = 1))
#' evaluatePerformance(beta, beta_imputed, na_positions)

evaluatePerformance <- function(beta_true, beta_imputed, na_positions) {

    beta_true_vec <- extract_values(beta_true, na_positions)
    beta_imputed_vec <- extract_values(beta_imputed, na_positions)
    
    RMSE <- sqrt(mean((beta_true_vec - beta_imputed_vec)^2, na.rm = TRUE))
    MAE <- mean(abs(beta_true_vec - beta_imputed_vec), na.rm = TRUE)
    PCC <- cor(beta_true_vec, beta_imputed_vec, use = "pairwise.complete.obs")
    
    Filt <- abs(beta_true_vec) != 0
    MAPE <- mean(abs((beta_true_vec[Filt] - beta_imputed_vec[Filt]) / 
                         beta_true_vec[Filt]), na.rm = TRUE)
    
    performance <- c("RMSE" = RMSE, "MAE" = MAE, 
                     "PCC" = PCC, "MAPE" = MAPE)
    return(performance)
}

test_that("Extraction of values from the matrix is correct", {
    expect_equal({
    A <- matrix(c(11, 12, 13,
                  21, 22, 23,
                  31, 32, 33), byrow = TRUE, nrow = 3)
    na_positions <- list("1" = list("na_col" = c(1), "na_rows" = c(1)),
                         "3" = list("na_col" = c(3), "na_rows" = c(2, 3)))
    A_vec <- methyLImp2:::extract_values(A, na_positions)
    
}, c(11, 23, 33))
    })

test_that("Performance evaluation is correct", {
          expect_equal({
              A <- matrix(c(11, 12, 13,
                            21, 22, 23,
                            31, 32, 33), byrow = TRUE, nrow = 3)
              na_positions <- list("1" = list("na_col" = c(1), "na_rows" = c(1)),
                                   "3" = list("na_col" = c(3), "na_rows" = c(2, 3)))
              
              A_imputed <- matrix(c(11, 12.2, 13,
                                    21, 22, 23,
                                    31, 32.2, 33.2), byrow = TRUE, nrow = 3)
              evaluatePerformance(A, A_imputed, na_positions)
}, c(RMSE = 0.115470053837927, MAE = 0.0666666666666676, PCC = 0.999983980905238, 
     MAPE = 0.00202020202020205))
    })

#' Generation of artificial missing values
#'
#' This function generates missing values for the simulation purposes 
#' (to apply \emph{methyLImp} method and then compare the imputed values with 
#' the true ones that have been replaced by NAs). 
#' First, we randomly choose 3\% of all probes. 
#' Then for each of the chosen probes, we randomly define the number of NAs 
#' from a Poisson distribution with \eqn{\lambda}, appropriate to the sample 
#' size of the dataset (unless specified by the user, here we use 
#' \eqn{\lambda = 0.15 * \#samples + 0.2}). Finally, these amount of NAs is 
#' randomly placed among the samples.
#'
#' @param beta a numeric data matrix into which one wants to add some missing values
#' @param lambda a number, parameter of the Poisson distribution that will 
#' indicate how many samples will have missing values in each selected probe.
#' 
#' @importFrom stats rpois
#' 
#' @return A list with two slots: a numeric data matrix with generated NAs in 
#' some entries and a list of positions of those NAs.
#'
#' @export
#' 
#' @examples
#' data(beta)
#' beta_with_nas <- generateMissingData(beta, lambda = 3.5)


generateMissingData <- function(beta, lambda = NULL) {
  
    #how many NAs do we have to start with?
    na_start <- sum(is.na(beta))
    message("The input dataset has ", na_start, " missing entries.")
  
    #let's save number of samples and number of probes
    nsamples <- dim(beta)[1]
    nprobes <- dim(beta)[2]
  
    #how many probes will have NAs?
    #according to the literature, around 3%
    nna <- floor(nprobes * 0.03)
    #which probes will have NAs?
    na_cols <- sample(seq_len(nprobes), size = nna)
  
    #we assume that number of NAs in the chosen probes follows Poisson distrubution.
    #if lambda is not provided by the user, we choose it by 
    #lambda = 0.15 * #samples - 0.2.
    #it's a linear model made to fit the parameters we have chosen 
    # in the simulation, which were
    # 1 for 9 samples
    # 2.5 for 17 samples
    # 5 for 34 samples
    # 7.5 for 51 samples
    # 10 for 68 samples
    if (is.null(lambda)) {
        lambda <- 0.15 * nsamples - 0.2
    }
  
    beta_with_nas <- beta
    
    #make a list where each element corresponds to a probe and 
    #it will store which samples are NA for that probe
    na_values <- vector(mode = "list", length = nna)
    names(na_values) <- na_cols
  
    for (i in seq_len(nna)) {
        #save column id
        na_values[[i]]$na_col <- na_cols[i]
    
        #for each probe, choose how many NAs it will have. 
        #If the number is 0, choose again
        curr_nna <- 0
        while (curr_nna == 0) {
            curr_nna <- rpois(n = 1, lambda = lambda)
        }
    
        #now sample, which samples are NA in the current probe
        na_values[[i]]$na_rows <- sample(seq_len(nsamples), size = curr_nna)
        #if those probes already have NAs (coming from original dataset), 
        #sample again
        while (sum(is.na(beta_with_nas[na_values[[i]]$na_rows, na_cols[i]])) != 0) {
            na_values[[i]]$na_rows <- sample(seq_len(nsamples), size = curr_nna)
        }
        #assign artificial NA
        beta_with_nas[na_values[[i]]$na_rows, na_cols[i]] <- NA
  }
  
    #what's the number of NAs now?
    na_imputed <- sum(is.na(beta_with_nas))
    message("After NA generation, the dataset has ", 
            na_imputed, " missing entries.")
  
    return(list("beta_with_nas" = beta_with_nas,
                "na_positions" = na_values))
}

test_that("Missing value generation is correct", {
    expect_equal({
        set.seed(1994)
        A <- matrix(rep(1, 1000), nrow = 10, ncol = 100)
        unlist(generateMissingData(A, lambda = 1)$na_positions)
    }, c(`88.na_col` = 88L, `88.na_rows1` = 4L, `88.na_rows2` = 6L, 
         `88.na_rows3` = 5L, `24.na_col` = 24L, `24.na_rows` = 5L, `11.na_col` = 11L, 
         `11.na_rows1` = 2L, `11.na_rows2` = 10L, `11.na_rows3` = 9L))
})

#' Split methylation dataset into a list by chromosomes
#'
#' This function split a given methylation dataset into a list of datasets according to a given annotation.
#'
#' @param data a numeric data matrix with with samples in rows and 
#' variables (probes) in named columns.
#' @param type a type of data, 450K or EPIC. Type is used to split CpGs across 
#' chromosomes. Match of CpGs to chromosomes is taken from ChAMPdata package. 
#' If you wish to provide your own match, specify "user" in 
#' this argument and provide a data frame in the next argument. 
#' @param annotation a data frame, user provided match between CpG sites and 
#' chromosomes. Must contain two columns: cpg and chr. Choose "user" in the 
#' previous argument to be able to provide user annotation.
#'
#' @import ChAMPdata
#' @importFrom utils data
#'
#' @return A list of numeric data matrices where each matrix contains probes 
#' from one chromosome.
#' @keywords internal
#' @noRd

split_by_chromosomes <- function(data,
                       type = c("450K", "EPIC", "user"),
                       annotation = NULL) {
    
    #load annotation
    type <- match.arg(type)
    if (type == "450K") {
        utils::data("hm450.manifest.hg19", package = "ChAMPdata",
                    envir = environment())
        anno <- data.frame(cpg = rownames(hm450.manifest.hg19), 
                           chr = hm450.manifest.hg19$CpG_chrm)
        remove(hm450.manifest.hg19)
    } else if (type == "EPIC") {
        utils::data("EPIC.manifest.hg19", package = "ChAMPdata",
                    envir = environment())
        anno <- data.frame(cpg = rownames(EPIC.manifest.hg19), 
                           chr = EPIC.manifest.hg19$CpG_chrm)
        remove(EPIC.manifest.hg19)
    } else if (type == "user") {
        anno <- annotation
    } 
    
    #split the data by chromosomes
    chromosomes <- unique(anno$chr)
    nchr <- length(chromosomes)
    data_chr <- vector(mode = "list", length = nchr)
    names(data_chr) <- chromosomes
    probes <- colnames(data)
    for (c in seq_len(nchr)) {
        curr_cpgs <- anno[anno$chr == chromosomes[c], ]$cpg
        data_chr[[c]] <- data[, colnames(data) %in% curr_cpgs, drop = FALSE]
        probes <- probes[! probes %in% curr_cpgs]
    }
    if (length(probes) != 0) {
        #answer <- readline("Some probes are not present in our annotation")
        warning("Some probes are not present in the annotation. They will not be imputed or used for imputation. Most probably, these are probes that have no match to a chromosome in Illumina manifest or are not present in the manifest at all. Consider using a custom annotation if you want to impute and/or use these columns in the imputation.")
    }
    #drop chromosomes that were not present in the the input dataset 
    #(if such exist)
    data_chr <- data_chr[names(data_chr)[vapply(data_chr, 
                                                function(x) 
                                                    dim(x)[2], numeric(1)) != 0]]
    nchr <- length(data_chr)
    #reorder chromosomes from biggest to smallest
    chr_order <- names(sort(vapply(data_chr, function(x) dim(x)[2],
                                   numeric(1)), 
                            decreasing = TRUE))
    data_chr <- data_chr[chr_order]
    
    return(data_chr)
}

#' Impute missing values in methylation dataset
#'
#' This function performs missing value imputation specific for DNA methylation 
#' data. The method is based on linear regression since methylation levels 
#' show a high degree of inter-sample correlation. Implementation is 
#' parallelised over chromosomes to improve the running time.
#'
#' @param input either a numeric data matrix with missing values to be, 
#' with named samples in rows and variables (probes) in named columns, or a 
#' SummarizedExperiment object, with an assay with variables in rows 
#' and samples in columns, as standard.
#' @param which_assay a character specifying the name of assay of the 
#' SummarizedExperiment object to impute. By default the first one will be imputed.
#' @param type a type of data, 450K or EPIC. Type is used to split CpGs across 
#' chromosomes. Match of CpGs to chromosomes is taken from ChAMPdata package. 
#' If you wish to provide your own match, specify "user" in 
#' this argument and provide a data frame in the next argument. 
#' @param annotation a data frame, user provided match between CpG sites and 
#' chromosomes. Must contain two columns: cpg and chr. Choose "user" in the 
#' previous argument to be able to provide user annotation.
#' @param groups a vector of the same length as the number of samples that 
#' identifies what groups does each sample correspond, e.g. \code{c(1, 1, 2, 3)}
#' or \code{c("group1", "group1", "group2", "group3")}. Unique elements of the 
#' vector will be identified as groups and data will be split accordingly. 
#' Imputation will be done for each group separately consecutively. 
#' The default is NULL, so all samples are considered as one group. 
#' @param range a vector of two numbers, \eqn{min} and \eqn{max}, 
#' specifying the range of values in the data. 
#' Since we assume the beta-value representation of the methylation data, 
#' the default range is \eqn{[0, 1]}. 
#' However, if a user wishes to apply the method to the other kind of data, 
#' they can change the range in this argument.
#' @param skip_imputation_ids a numeric vector of ids of the columns with NAs  
#' for which \emph{not} to perform the imputation. If \code{NULL}, all columns 
#' are considered.
#' @param BPPARAM set of options for parallelization through BiocParallel package.
#' For details we refer to their documentation. The one thing most users probably
#' wish to customize is the number of cores. By default it is set to 
#' \eqn{\#cores - 2}. If you wish to change is, supply
#' \code{BBPARAM = SnowParam(workers = ncores)} with your desired \code{ncores}.
#' If the default or user-specified number of workers is higher than number of 
#' chromosomes, it will be overwritten.
#' We also recommend setting \code{exportglobals = FALSE} since it can help reduce
#' running time.
#' @param minibatch_frac a number between 0 and 1, what fraction of samples 
#' to use for mini-batch computation. Remember that if your data has several groups, 
#' mini-batch will be applied to each group separately but with the same fraction, 
#' so choose it accordingly. However, if your chosen fraction will be smaller 
#' than a matrix dimension for some groups, mini-batch will be just ignored. 
#' We advise to use mini-batch only if you have large number of samples, 
#' order of hundreds. The default is 1 (i.e., 100\% of samples are used, 
#' no mini-batch). 
#' @param minibatch_reps a number, how many times to repeat computations with 
#' a fraction of samples specified above (more times -> better performance but 
#' more runtime). The default is 1 (as a companion to default fraction of 100\%,
#' i.e. no mini-batch).
#' @param overwrite_res a boolean specifying whether to overwrite an imputed slot
#' of the SummarizedExperiment object or to add another slot with 
#' imputed data. The default is \code{TRUE} to reduced the object size.
#'
#' @importFrom BiocParallel SnowParam bplapply bpstart bpstop
#' @importFrom parallel detectCores
#' @importFrom SummarizedExperiment assays assay assayNames
#' @importFrom methods is
#'
#' @return Either a numeric matrix with imputed data or a SummarizedExperiment 
#' object.
#'
#' @export
#' 
#' @examples
#' data(beta)
#' beta_with_nas <- generateMissingData(beta, lambda = 3.5)$beta_with_nas
#' beta_imputed <- methyLImp2(input = beta_with_nas, type = "EPIC", 
#'                           minibatch_frac = 0.5, 
#'                           BPPARAM = BiocParallel::SnowParam(workers = 1))

methyLImp2 <- function(input, which_assay = NULL,
                      type = c("450K", "EPIC", "user"),
                      annotation = NULL,
                      groups = NULL,
                      range = NULL,
                      skip_imputation_ids = NULL,
                      BPPARAM = BiocParallel::bpparam(),
                      minibatch_frac = 1, minibatch_reps = 1,
                      overwrite_res = TRUE) {
  
    #check the class of input
    if (is.matrix(input)) {
        if (is.numeric(input)) {
            data_full <- input
            flag <- "matrix"
            if (is.null(rownames(input))) {
                stop("Please provide rownames for the input matrix.")
            }
            if (is.null(colnames(input))) {
                stop("Please provide colnames for the input matrix.")
            }
        } else {
            stop("The input matrix is not numeric.") 
        }
    } else if (is(input, "SummarizedExperiment")) {
        if (is.null(which_assay)) {
            data_full <- t(assay(input))
        } else {
            if (which_assay %in% assayNames(input)) {
                data_full <- t(assay(input, which_assay))
            } else {
                stop("Please provide correct assay name.")
            }
        }
        flag <- "SE"
    } else {
        stop("Input is not a numeric matrix or a SummarizedExperiment object.")
    }
    
    #check annotation
    type <- match.arg(type)
    if (! type %in% c("450K", "EPIC", "user")) {
        stop("Choose type of data correctly to select annotation: 450K or EPIC - or provide your own annotation.")
    }
    if (type == "user") {
        if (is.null(annotation)) {
            stop("Please provide annotation: a data frame with cpg and chr columns.")
        } else if (sum(colnames(data_full) %in% annotation$cpg) == 0) {
            stop ("CpG names in the annotation and in the input data do not match.")
        }
    } 
    
    #check the provided data range
    if (is.null(range)) {
        min <- 0
        max <- 1
    } else {
        if (length(range) != 2) {
            stop("Range must be a vector of two numbers.")
        } else {
            if (range[1] >= range[2]) {
                stop("Left entry of the interval must be less than the right one.")
            } else {
                min <- range[1]
                max <- range[2]
            }
        }
    }
    
    #check the parallelization set-up
    {
        #split the data by chromosomes to see the nchr
        data_chr_full <- split_by_chromosomes(data = data_full, type = type,
                                              annotation = annotation)
        nchr <- length(data_chr_full)
        
        if (BPPARAM$tasks != 0 & BPPARAM$tasks != nchr) {
            BPPARAM$tasks <- nchr
            warning("BPPARAM$tasks parameter must be equal to the number of chromosomes. Your input was overwritten.")
        }
        
        if (nchr < BPPARAM$workers) {
            BPPARAM$workers <- nchr
            warning("Number of chromosomes is less than specified BPPARAM$workers. Your input was overwritten since more cores than number of chromosomes is not necessary.")
        }
        
        if (is.null(BPPARAM$RNGseed)) {
            BPPARAM$RNGseed <- 1994
        }
        
        if (BPPARAM$exportglobals) {
            warning("BPPARAM$exportglobals = TRUE. Setting it to FALSE may reduce the running time.")
        }
    }
    
    #check groups
    if (is.null(groups)) {
        groups <- rep(1, dim(data_full)[1])
    } else if (is.vector(groups)) {
        if (length(groups) != dim(data_full)[1]) {
            stop("Length of the groups vector does not match number of samples in the input argument.")
        } 
    } else {
        stop("Object provided for the groups argument is not a vector.")
    }
  
    unique_groups <- unique(groups)
    ngroups <- length(unique_groups)
    samples_order <- rownames(data_full)
    out_full <- vector(mode = "list", length = ngroups)
    
    for (i in seq_len(ngroups)) {
        curr_group <- unique_groups[i]
        data_group <- data_full[groups == curr_group, ]
        
        data_chr <- vector(mode = "list", length = nchr)
        names(data_chr) <- names(data_chr_full)
        for (j in seq_len(nchr)) {
            data_chr[[j]] <- data_chr_full[[j]][groups == curr_group, ]
        }
        
        #run methyLImp in parallel for each chromosome
        bpstart(BPPARAM)
        res <- bplapply(data_chr, methyLImp2_internal, 
                         min, max, skip_imputation_ids,
                         minibatch_frac, minibatch_reps,
                         BPPARAM = BPPARAM)
        bpstop(BPPARAM)
        
        names(res) <- names(data_chr)
        
        #if some chromosomes didn't have NAs or didn't have enough data for imputation,
        #tell this to the user and then later skip them in the replacement stage
        problem_chr <- c()
        if (sum(vapply(res, function(x) is.character(x), logical(1))) > 0) {
            problem_chr <- names(data_chr)[vapply(res, function(x) is.character(x), 
                                                  logical(1))]
            for (prb in 1:length(problem_chr)) {
                message("Sample group " , curr_group, ", ", 
                        problem_chr[prb], ": ", res[problem_chr[prb]])
            }
        }
        
        #replace NAs with imputed values
        out <- data_group
        for (c in seq_len(nchr)) {
            if (names(res)[c] %in% problem_chr) next
            imputed <- res[[c]]
            rows_id <- rownames(data_group) %in% rownames(imputed)
            cols_id <- colnames(data_group) %in% colnames(imputed)
            out[rows_id, cols_id] <- imputed
        }
        
        out_full[[i]] <- out
    }
    
    out_full <- do.call(rbind, out_full)
    out_full <- out_full[samples_order, ]
    
    if (flag == "SE") {
        if (overwrite_res) {
            if (is.null(which_assay)) {
                assay(input) <- t(out_full)
            } else {
                assay(input, which_assay) <- t(out_full)
            }    
            return(input)
        } else {
            assay(input, paste(which_assay, "_imputed", sep = "_")) <- 
                t(out_full)
            return(input)
        }
    } else {
        return(out_full)
    }
    
}

#' Impute missing values in methylation dataset
#'
#' @param dat a numeric data matrix with missing values, 
#' with samples in rows and variables (probes) in columns.
#' @param min a number, minimum value for bounded-range variables. 
#' Default is 0 (we assume beta-value representation of the methylation data). 
#' Can be user provided in case of other types of data.
#' @param max a number, maximum value for bounded-range variables. 
#' Default is 1 (we assume beta-value representation of the methylation data). 
#' Can be user provided in case of other types of data.
#' @param skip_imputation_ids a numeric vector of ids of the columns with NAs for which 
#' \emph{not} to perform the imputation. If \code{NULL}, all columns are considered.
#' @param minibatch_frac a number, what percentage of samples to use for 
#' mini-batch computation. The default is 1 (i.e., 100\% of samples are used, 
#' no mini-batch).
#' @param minibatch_reps a number, how many times repeat computations with a 
#' fraction of samples (more times - better performance). 
#' The default is 1 (as a companion to default fraction of 100\%. i.e. no mini-batch).
#'
#' @return A numeric matrix \eqn{out} with imputed data is returned.
#' 
#' @keywords internal
#' @noRd

methyLImp2_internal <- function(dat,
                                min, max,
                                skip_imputation_ids,
                                minibatch_frac, minibatch_reps) {
    
    #let's identify columns with same patterns of NAs
    {
        colnames_dat <- colnames(dat)
        
        #detect NAs
        dat_na <- is.na(dat)
        #exclude columns with no NAs
        dat_na <- dat_na[, colSums(dat_na) > 0, drop = FALSE]
        if (dim(dat_na)[2] == 0) {
            return("No columns with missing values detected.")
        }
        #save all columns with NA
        all_NA_cols <- which(colnames_dat %in% colnames(dat_na))
        # exclude from the imputation columns with all NAs or 
        # a single not NA value: not enough information for imputation
        dat_na <- dat_na[, colSums(dat_na) < (dim(dat_na)[1] - 1), drop = FALSE]
        
        #If all the columns have missing values we cannot do anything
        if (dim(dat_na)[2] == dim(dat)[2]) {
            return("No CpGs without any missing values, not possible to conduct imputation.")
        } 
        
        unique_patterns <- unique(t(dat_na))
        npatterns <- dim(unique_patterns)[1]
        
        ids <- vector(mode = "list", length = npatterns)
        
        for (i in seq_len(npatterns)) {
            curr_pattern <- unique_patterns[i, ]
            
            col_match <- apply(dat_na, 2, function(x) identical(x, curr_pattern))
            col_match <- colnames(dat_na)[col_match]
            NAcols_id <- which(colnames_dat %in% col_match)
            #if some of the chosen columns are restricted by user, exclude them
            if(!is.null(skip_imputation_ids)) {
                NAcols_id <- NAcols_id[!(NAcols_id %in% skip_imputation_ids)]
            }
            
            row_id <- which(curr_pattern == TRUE)
            
            ids[[i]] <- list(row_id = row_id, NAcols_id = NAcols_id)
        }
        
        names(ids) <- paste("group", seq_len(npatterns), sep = "_")
        
    }
    
    out <- dat
    for (j in seq_len(npatterns)) {
        row_id <- ids[[j]]$row_id
        NAcols_id <- ids[[j]]$NAcols_id
        
        C <- dat[row_id, -all_NA_cols]
        
        A_full <- dat[-row_id, -all_NA_cols]
        B_full <- dat[-row_id, NAcols_id]
        
        imputed_list <- vector(mode = "list", length = minibatch_reps)
        for (r in seq_len(minibatch_reps)) {
            sample_size <- ifelse(dim(A_full)[1] > ceiling(dim(A_full)[1] * 
                                                               minibatch_frac),
                                  ceiling(dim(A_full)[1] * minibatch_frac),
                                  dim(A_full)[1])
            chosen_rows <- sort(sample(seq_len(dim(A_full)[1]), 
                                       size = sample_size))
            A <- A_full[chosen_rows, , drop = FALSE]
            if (is.null(dim(B_full))) {
                B <- B_full[chosen_rows]
            } else {
                B <- B_full[chosen_rows, ]
            }
            
            # Updates or computes max.sv from A. Negative or zero value not allowed
            max.sv <- NULL
            max.sv <- max(ifelse(is.null(max.sv), min(dim(A)), max.sv), 1)
            
            if(is.null(min) || is.null(max)) {
                # Unrestricted-range imputation
                # X <- pinvr(A, rank) %*% B (X = A^-1 * B)
                # O <- C %*% X             (O = C*X)
                imputed_list[[r]] <- C %*% (methyLImp2:::pinvr(A, max.sv) %*% B)
            } else {
                # Bounde-range imputation
                # X <- pinvr(A, rank) %*% logit(B, min, max) (X = A^-1 * logit(B))
                # P <- inv.logit(C %*% X, min, max)         (P = logit^-1 (C * X))
                imputed_list[[r]] <- methyLImp2:::inv.plogit(C %*% 
                                                                 (methyLImp2:::pinvr(A, max.sv) %*%
                                                                      methyLImp2:::plogit(B, min, max)), min, max)
            }
        }
        
        imputed <- Reduce('+', imputed_list) / minibatch_reps
        out[row_id, NAcols_id] <- imputed
    }
    
    return(out)
    
}

test_that("Chromosome split is correct", {
    expect_equal({
        A <- matrix(rep(1, 1000), nrow = 10, ncol = 100)
        colnames(A) <- paste("col", 1:100, sep = "")
        anno <- data.frame(cpg = paste("col", 1:100, sep = ""), 
                           chr = c(rep("A", 50), rep("B", 50)))
        A_chr <- methyLImp2:::split_by_chromosomes(A, type = "user", 
                                                   annotation = anno)
        length(A_chr)
    },
    2)
    expect_equal({
        A <- matrix(rep(1, 1000), nrow = 10, ncol = 100)
        colnames(A) <- paste("col", 1:100, sep = "")
        anno <- data.frame(cpg = paste("col", 1:100, sep = ""), 
                           chr = c(rep("A", 50), rep("B", 50)))
        A_chr <- methyLImp2:::split_by_chromosomes(A, type = "user", 
                                                   annotation = anno)
        sapply(A_chr, function(x) class(x)[1])
    },
    c(A = "matrix", B = "matrix"))
})

test_that("Imputation is correct", {
    expect_equal({
        set.seed(1994)
        A <- matrix(rep(1, 1000), nrow = 10, ncol = 100)
        rownames(A) <- paste("row", 1:10, sep = "")
        colnames(A) <- paste("col", 1:100, sep = "")
        anno <- data.frame(cpg = paste("col", 1:100, sep = ""), 
                           chr = c(rep("A", 50), rep("B", 50)))
        A_with_nas <- generateMissingData(A, lambda = 1)
        A_imp <- methyLImp2(input = A_with_nas$beta_with_nas,
                            type = "user",
                            annotation = anno)
        methyLImp2:::extract_values(A_imp, A_with_nas$na_positions)
    },
    rep(1, 7))
})

#' A subset of GSE199057 dataset for vignette demonstration
#'
#' The GSE199057 Gene Expression Omnibus dataset contains 68 mucosa samples 
#' from non-colon-cancer patients, from which we randomly sampled 24. 
#' Methylation data were measured on EPIC arrays and after removal of 
#' sex chromosomes and SNPs loci, it contains 816 126 probes. 
#' Pre-processing can be found on the _methyLImp2_ simulation github page 
#' https://github.com/annaplaksienko/methyLImp2_simulation_studies.
#' Here we subset only a quarter of probes from two smallest chromosomes (18 and 21) 
#' for the sake of demonstration. 
#'
#' @docType data
#'
#' @usage data(beta)
#'
#' @format A numeric matrix
#' @return A numeric matrix
#'
#' @keywords datasets
#'
#' @source https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi
"beta"

#' Metadata information for GSE199057 dataset for vignette demonstration
#'
#' The GSE199057 Gene Expression Omnibus dataset contains 68 mucosa samples 
#' from non-colon-cancer patients, from which we randomly sampled 24. 
#' Dataset contains metadata for those.
#'
#' @docType data
#'
#' @usage data(beta_meta)
#'
#' @format A data.frame
#' @return A data.frame.
#'
#' @keywords datasets
#' @noRd
#'
#' @source https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi
"beta_meta"

#' An example of how custom (user provided) annotation data frame should look like
#'
#' A snippet from an annotation for 450K methylation dataset from ChAMPdata package. Only 5 CpGs are chosen simply to provide an example of the data frame organization.
#'
#' @docType data
#'
#' @usage data(custom_anno_example)
#'
#' @format A data.frame
#' @return A data.frame.
#'
#' @keywords datasets
"custom_anno_example"

#' Pseudo-logit function 
#'
#' @param X a numeric matrix
#' @param min a number, default value is 0
#' @param max a number, default value is 1
#'
#' @return A numeric matrix 
#'
#' @keywords internal
#' @noRd

plogit <- function(X, min = 0, max = 1)
{
    p <- (X - min) / (max - min)
    # fix -Inf
    p <- ifelse(p < .Machine$double.neg.eps, .Machine$double.neg.eps, p)
    # fix +Inf
    p <- ifelse(p > 1 - .Machine$double.neg.eps, 1 - .Machine$double.neg.eps, p)
    log(p / (1 - p))
}


#' Inverse of the pseudo-logit function.
#'
#' @param X a numeric matrix
#' @param min a number, default value is 0
#' @param max a number, default value is 1
#'
#' @return A numeric matrix 
#' 
#' @keywords internal
#' @noRd

inv.plogit <- function(X, min = 0, max = 1) {
    p <- exp(X) / (1 + exp(X))
    # fix problems with +Inf
    p <- ifelse(is.na(p) & !is.na(X), 1, p )
    # fix 0 rounding
    p <- ifelse(p <= exp(plogit(0)) / (1 + exp(plogit(0))), 0, p)
    p * (max - min) + min
}

#' Computes the Moore-Penrose generalized inverse of a matrix. 
#' Allows rank reduction of the generalized inverse.
# '
#' This function is directly taken from MASS package (code on GPLv3 license) 
#' and modified in order to include the rank reduction option. 
#' The added code for rank reduction is commented in the implementation.
#'
#' @param X a numeric matrix
#' @param tol a number
#' 
#' @importFrom corpcor fast.svd
#'
#' @return A numeric matrix 
#'
#' @keywords internal
#' @noRd

pinvr <- function(X, max.sv = min(dim(X)), tol = sqrt(.Machine$double.eps)) {
    # based on suggestions of R. M. Heiberger, T. M. Hesterberg and WNV
  
    if(length(dim(X)) > 2L || !(is.numeric(X) || is.complex(X)))
        stop("'X' must be a numeric or complex matrix")
    if(!is.matrix(X)) X <- as.matrix(X)
    Xsvd <- fast.svd(X)
    if(is.complex(X)) Xsvd$u <- Conj(Xsvd$u)
    Positive <- Xsvd$d > max(tol * Xsvd$d[1L], 0)

    # Rank reduction extension: START
    max.sv <- min(ifelse(max.sv < 0, 1, max.sv), min(dim(X)))
    L <- logical(length(Positive))
    L[seq_len(max.sv)] <- TRUE
    Positive <- Positive & L
    # Rank reduction extension: END

    if (all(Positive)) Xsvd$v %*% (1 / Xsvd$d * t(Xsvd$u))
    else if(!any(Positive)) array(0, dim(X)[2L:1L])
    else Xsvd$v[, Positive, drop = FALSE] %*% 
        ((1 / Xsvd$d[Positive]) * t(Xsvd$u[, Positive, drop = FALSE]))
}

test_that("Pseudo-logit function is correct", {
    expect_equal({
        A <- matrix(c(0.11, 0.12, 
                      0.21, 0.22), byrow = TRUE, nrow = 2)
        round(plogit(A), digits = 2)
    },
    matrix(c(-2.09, -1.99,
             -1.32, -1.27), byrow = TRUE, nrow = 2))
})

test_that("Inverse of pseudo-logit function is correct", {
    expect_equal({
        B <- matrix(c(-2.09, -1.99,
                      -1.32, -1.27), byrow = TRUE, nrow = 2)
        round(inv.plogit(B), digits = 2)
    },
    matrix(c(0.11, 0.12, 
             0.21, 0.22), byrow = TRUE, nrow = 2))
})

test_that("Moore-Penrose generalized inverse of a matrix is correct", {
    expect_equal({
        A <- matrix(c(0.11, 0.12, 
                      0.21, 0.22), byrow = TRUE, nrow = 2)
        pinvr(A)
    },
    matrix(c(-220, 120,
             210, -110), byrow = TRUE, nrow = 2))
})

## ----knitr options, include = FALSE-------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----setup, message = FALSE---------------------------------------------------
library(methyLImp2)
library(SummarizedExperiment)
library(BiocParallel)

## ----installation, eval = FALSE-----------------------------------------------
# if (!require("BiocManager", quietly = TRUE))
#     install.packages("BiocManager")
# 
# BiocManager::install("methyLImp2")

## ----load the dataset---------------------------------------------------------
data(beta, package = "methyLImp2")
print(dim(beta))

## ----generate artificial NAs--------------------------------------------------
with_missing_data <- generateMissingData(beta, lambda = 3.5)
beta_with_nas <- with_missing_data$beta_with_nas
na_positions <- with_missing_data$na_positions

## ----construct SE-------------------------------------------------------------
data(beta_meta)
beta_SE <- SummarizedExperiment(assays = SimpleList(beta = t(beta_with_nas)), 
                                colData = beta_meta)

## ----user annotation example, echo = FALSE------------------------------------
data(custom_anno_example)
knitr::kable(custom_anno_example)

## ----run methyLImp------------------------------------------------------------
time <- system.time(beta_SE_imputed <- methyLImp2(input = beta_SE, 
                                               type = "EPIC", 
                                               BPPARAM = SnowParam(exportglobals = FALSE),
                                               minibatch_frac = 0.5))
print(paste0("Runtime was ", round(time[3], digits = 2), " seconds."))

## ----evaluate performance-----------------------------------------------------
performance <- evaluatePerformance(beta, t(assays(beta_SE_imputed)[[1]]), 
                                   na_positions)
print(performance)

## ----sessionInfo--------------------------------------------------------------
sessionInfo()

---
title: "methyLImp2 vignette"
author: "Anna Plaksienko"
package: methyLImp2
output: 
    BiocStyle::html_document
vignette: >
    %\VignetteIndexEntry{methyLImp2 vignette}
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteEncoding{UTF-8}  
---

```{r knitr options, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

```{r setup, message = FALSE}
library(methyLImp2)
library(SummarizedExperiment)
library(BiocParallel)
```
# Introduction

DNA methylation profiles often contain multiple missing values due to some technological problems. Meanwhile, methods for downstream analysis of such data require you to perform imputation of those missing values first. Although several imputation methods exist, most are inefficient with large dimensions and are not specific to methylation datasets. Previously, we have introduced *methyLImp* - imputation method that exploits inter-sample correlation in the methylation data in its model and also does imputation simultaneously for all CpGs with the same missingness pattern (i.e. NAs in the same samples). Although it demonstrated great performance in comparison with other methods (see [here](https://pubmed.ncbi.nlm.nih.gov/30796811/)), there was still a room for improvement in terms of the running time. Therefore, we upgraded it to *methyLImp2*!

This version is parallelized over chromosomes and, optionally, in case of large sample size, can use mini-batch approach. In our simulation study these two improvements allowed to reduce the running time from more than a day to just half an hour for the EPIC dataset of 456 samples!

In this vignette we will demonstrate the usage of the *methyLImp2* package for the imputation of the missing values in the methylation dataset. More details about the method itself can be found in [the manuscript](https://academic.oup.com/bioinformatics/article/40/1/btae001/7517106). If you use our package in your research and wish to support us, kindly cite the paper (see `citation(package = "methyLImp2")`).

## Installation
To install *methyLImp2* from Bioconductor, run
```{r installation, eval = FALSE}
if (!require("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("methyLImp2")
```


# Using *methyLImp2*

In this section we demonstrate the usage of the *methyLImp2* method. This section consists of four parts: data description, generation of the artificial missing values into example dataset (since we need to know the true values for the performance evaluation), application of *methyLImp2* method and then performance evaluation (we compare imputed values with the true ones). 

## About the data

Typically, imputation of the missing values is done before any other steps, like normalization, data exploration, analysis etc. Note that some packages do imputation while loading .idat files into R, so then you should set that step accordingly, to be able to use *methyLImp* after loading the data.

Here we use a subset of GSE199057 Gene Expression Omnibus dataset with mucosa samples from non-colon-cancer patients.  Methylation data were measured on EPIC arrays. For the sake of vignette and due to package size restrictions, we reduce the number of samples from 68 to randomly sampled 24. We also restricted the dataset to the two shortest chromosomes, 18 and 21, using only a quarter of probes from each, and filtered out SNPs, so the total number of probes is 6064. We refer the reader to our [simulation studies](https://github.com/annaplaksienko/methyLImp2_simulation_studies) for full size dataset performance and running time results. 

This dataset is a numeric matrix. You can use it as an input for *methyLImp2*. Data should be in a "tidy" format, i.e. with samples in rows and variables (probes, CpGs) in columns. However, if you use another possible input format, SummarizedExperiment, dimensions should be reversed (see later).

```{r load the dataset}
data(beta, package = "methyLImp2")
print(dim(beta))
```


## Missing values generation

Here we add artificial NAs into the dataset and memorize their positions so that we can later evaluate the performance of the method. We first randomly chose 3\% of probes to have artificial NAs. Then, for each probe, we randomly defined the number of NAs from a Poisson distribution with $\lambda$ appropriate to the sample size of the dataset (here for 24 samples we use $\lambda = 3.5$). Finally, these NAs are randomly placed among the samples. 

`generateMissingData` function returns a list of two objects: matrix of beta values with artificial NAs and a list of positions of those NAs (columns and then rows for each column). We'll need that second object to be able to evaluate performance later (since the dataset already has some ''natural'' and, therefore, "unevaluatable" NAs, we can't just directly compare two matrices, we need to know which entries to compare.)

```{r generate artificial NAs}
with_missing_data <- generateMissingData(beta, lambda = 3.5)
beta_with_nas <- with_missing_data$beta_with_nas
na_positions <- with_missing_data$na_positions
```

As already mentioned, you can provide a numeric matrix as an argument for *methyLImp2*. However, as many users work with SummarizedExperiment objects in the Bioconductor workflow, we will construct such object here for the sake of demonstration. Note how we transpose the matrix since typical assay format is variables in rows and samples in columns. 
```{r construct SE}
data(beta_meta)
beta_SE <- SummarizedExperiment(assays = SimpleList(beta = t(beta_with_nas)), 
                                colData = beta_meta)
```

## Using methyLImp2

Now, let's run *methyLImp2*! You start by providing either a numeric data matrix with missing values, with samples in rows and variables (probes) in columns, or a SummarizedExperiment object, from which the first assays slot will be imputed. You also need to provide the type of your data - 450k or EPIC. These are the only two arguments you have to provide. However, there are a few other things you can tune so that the method suits your needs best: 

* Specify what groups you have in your data. *methyLImp2* works best when imputation is done on each group of samples independently. Therefore, you should specify the correspondence of samples to groups. *methyLImp2* will split the data by groups, perform imputation and put the data back together. Here we've already pre-filtered the data to only one group, so we do not use this argument;

* Specify the type of data as "user-provided". Type of data (450k or EPIC) is used to split CpGs across chromosomes. Match of CpGs to chromosomes is taken from ChAMPdata package (there, in turn, it comes from Illumina website). Therefore, if you wish to provide your own match, specify "user" in the type argument and then provide an annotation data frame with in the annotation argument (see example below); 

```{r user annotation example, echo = FALSE}
data(custom_anno_example)
knitr::kable(custom_anno_example)
```

* Set up mini-batch computation. If your dataset is quite big sample-wise, you can opt to use only a fraction of samples for the imputation to decrease the running time, say 10, 20, 50% (depending on the original number of samples). Subsample will be chosen randomly for each calculation. The bigger the subsample - the better is the performance, hence by default it is 1. An option to improve the performance but still keep the running time low is to repeat computation for a (randomly chosen) fraction of samples several times, maybe 2, 3, 5. In the manuscript we explore how these two tuning parameters influence the running time and the performance.

* Choose the number of cores/workers. *methyLImp2* first splits the data by chromosomes and then does imputation for each subset in parallel. The default of the `BiocParallel` package is two less than total number of your cores. You can change it to your chosen N by setting `BPPARAM = SnowParam(workers = N)`. Since here we have only two chromosomes, *methyLImp2* will give a warning that it overwrote default settings. Note that we also encourage you to set `exportglobals = FALSE` since it allows to slightly speed up the computation; 

* Choose not to overwrite your data with the imputed one. Here we opt to use the default setting and overwrite the existing assay of the SummarizedExperiment object to save memory. However, you can set `overwrite_res = FALSE` and then another slot will be added.

```{r run methyLImp}
time <- system.time(beta_SE_imputed <- methyLImp2(input = beta_SE, 
                                               type = "EPIC", 
                                               BPPARAM = SnowParam(exportglobals = FALSE),
                                               minibatch_frac = 0.5))
print(paste0("Runtime was ", round(time[3], digits = 2), " seconds."))
```

## Performance evaluation

Now we evaluate the performance of the algorithm with root mean square error (RMSE), mean absolute error (MAE), mean absolute percentage error (MAPE) - the lower the values are, the better - and Pearson correlation coefficient (PCC) - closer to 1, the better.

```{r evaluate performance}
performance <- evaluatePerformance(beta, t(assays(beta_SE_imputed)[[1]]), 
                                   na_positions)
print(performance)
```


# Session info

```{r sessionInfo}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{custom_anno_example}
\alias{custom_anno_example}
\title{An example of how custom (user provided) annotation data frame should look like}
\format{
A data.frame
}
\usage{
data(custom_anno_example)
}
\value{
A data.frame.
}
\description{
A snippet from an annotation for 450K methylation dataset from ChAMPdata package. Only 5 CpGs are chosen simply to provide an example of the data frame organization.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{beta}
\alias{beta}
\title{A subset of GSE199057 dataset for vignette demonstration}
\format{
A numeric matrix
}
\source{
https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi
}
\usage{
data(beta)
}
\value{
A numeric matrix
}
\description{
The GSE199057 Gene Expression Omnibus dataset contains 68 mucosa samples 
from non-colon-cancer patients, from which we randomly sampled 24. 
Methylation data were measured on EPIC arrays and after removal of 
sex chromosomes and SNPs loci, it contains 816 126 probes. 
Pre-processing can be found on the _methyLImp2_ simulation github page 
https://github.com/annaplaksienko/methyLImp2_simulation_studies.
Here we subset only a quarter of probes from two smallest chromosomes (18 and 21) 
for the sake of demonstration.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methyLImp2.R
\name{methyLImp2}
\alias{methyLImp2}
\title{Impute missing values in methylation dataset}
\usage{
methyLImp2(
  input,
  which_assay = NULL,
  type = c("450K", "EPIC", "user"),
  annotation = NULL,
  groups = NULL,
  range = NULL,
  skip_imputation_ids = NULL,
  BPPARAM = BiocParallel::bpparam(),
  minibatch_frac = 1,
  minibatch_reps = 1,
  overwrite_res = TRUE
)
}
\arguments{
\item{input}{either a numeric data matrix with missing values to be, 
with named samples in rows and variables (probes) in named columns, or a 
SummarizedExperiment object, with an assay with variables in rows 
and samples in columns, as standard.}

\item{which_assay}{a character specifying the name of assay of the 
SummarizedExperiment object to impute. By default the first one will be imputed.}

\item{type}{a type of data, 450K or EPIC. Type is used to split CpGs across 
chromosomes. Match of CpGs to chromosomes is taken from ChAMPdata package. 
If you wish to provide your own match, specify "user" in 
this argument and provide a data frame in the next argument.}

\item{annotation}{a data frame, user provided match between CpG sites and 
chromosomes. Must contain two columns: cpg and chr. Choose "user" in the 
previous argument to be able to provide user annotation.}

\item{groups}{a vector of the same length as the number of samples that 
identifies what groups does each sample correspond, e.g. \code{c(1, 1, 2, 3)}
or \code{c("group1", "group1", "group2", "group3")}. Unique elements of the 
vector will be identified as groups and data will be split accordingly. 
Imputation will be done for each group separately consecutively. 
The default is NULL, so all samples are considered as one group.}

\item{range}{a vector of two numbers, \eqn{min} and \eqn{max}, 
specifying the range of values in the data. 
Since we assume the beta-value representation of the methylation data, 
the default range is \eqn{[0, 1]}. 
However, if a user wishes to apply the method to the other kind of data, 
they can change the range in this argument.}

\item{skip_imputation_ids}{a numeric vector of ids of the columns with NAs
for which \emph{not} to perform the imputation. If \code{NULL}, all columns 
are considered.}

\item{BPPARAM}{set of options for parallelization through BiocParallel package.
For details we refer to their documentation. The one thing most users probably
wish to customize is the number of cores. By default it is set to 
\eqn{\#cores - 2}. If you wish to change is, supply
\code{BBPARAM = SnowParam(workers = ncores)} with your desired \code{ncores}.
If the default or user-specified number of workers is higher than number of 
chromosomes, it will be overwritten.
We also recommend setting \code{exportglobals = FALSE} since it can help reduce
running time.}

\item{minibatch_frac}{a number between 0 and 1, what fraction of samples 
to use for mini-batch computation. Remember that if your data has several groups, 
mini-batch will be applied to each group separately but with the same fraction, 
so choose it accordingly. However, if your chosen fraction will be smaller 
than a matrix dimension for some groups, mini-batch will be just ignored. 
We advise to use mini-batch only if you have large number of samples, 
order of hundreds. The default is 1 (i.e., 100\% of samples are used, 
no mini-batch).}

\item{minibatch_reps}{a number, how many times to repeat computations with 
a fraction of samples specified above (more times -> better performance but 
more runtime). The default is 1 (as a companion to default fraction of 100\%,
i.e. no mini-batch).}

\item{overwrite_res}{a boolean specifying whether to overwrite an imputed slot
of the SummarizedExperiment object or to add another slot with 
imputed data. The default is \code{TRUE} to reduced the object size.}
}
\value{
Either a numeric matrix with imputed data or a SummarizedExperiment 
object.
}
\description{
This function performs missing value imputation specific for DNA methylation 
data. The method is based on linear regression since methylation levels 
show a high degree of inter-sample correlation. Implementation is 
parallelised over chromosomes to improve the running time.
}
\examples{
data(beta)
beta_with_nas <- generateMissingData(beta, lambda = 3.5)$beta_with_nas
beta_imputed <- methyLImp2(input = beta_with_nas, type = "EPIC", 
                          minibatch_frac = 0.5, 
                          BPPARAM = BiocParallel::SnowParam(workers = 1))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/generateMissingData.R
\name{generateMissingData}
\alias{generateMissingData}
\title{Generation of artificial missing values}
\usage{
generateMissingData(beta, lambda = NULL)
}
\arguments{
\item{beta}{a numeric data matrix into which one wants to add some missing values}

\item{lambda}{a number, parameter of the Poisson distribution that will 
indicate how many samples will have missing values in each selected probe.}
}
\value{
A list with two slots: a numeric data matrix with generated NAs in 
some entries and a list of positions of those NAs.
}
\description{
This function generates missing values for the simulation purposes 
(to apply \emph{methyLImp} method and then compare the imputed values with 
the true ones that have been replaced by NAs). 
First, we randomly choose 3\% of all probes. 
Then for each of the chosen probes, we randomly define the number of NAs 
from a Poisson distribution with \eqn{\lambda}, appropriate to the sample 
size of the dataset (unless specified by the user, here we use 
\eqn{\lambda = 0.15 * \#samples + 0.2}). Finally, these amount of NAs is 
randomly placed among the samples.
}
\examples{
data(beta)
beta_with_nas <- generateMissingData(beta, lambda = 3.5)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/evaluatePerformance.R
\name{evaluatePerformance}
\alias{evaluatePerformance}
\title{Evaluate performance metrics: root mean square error (RMSE), 
mean absolute error (MAE), mean absolute percentage error (MAPE) and
Pearson correlation coefficient (PCC).}
\usage{
evaluatePerformance(beta_true, beta_imputed, na_positions)
}
\arguments{
\item{beta_true}{first numeric data matrix.}

\item{beta_imputed}{second numeric data matrix}

\item{na_positions}{a list where each element is a list of two elements: 
column id and ids of rows with NAs in that column (structure matches the 
output of generateMissingData function). We need this because some NAs in 
the dataset are from real data and not artificial, so we can't evaluate the 
performance of the method on them since we do not know real value. 
Therefore, we need to know the positions of artificial NAs.}
}
\value{
A numerical vector of four numbers: root mean square error (RMSE), 
mean absolute error (MAE), mean absolute percentage error (MAPE) and
Pearson correlation coefficient (PCC).
}
\description{
This function computes performance metrics as an element-wise difference 
between two matrices (skipping NA elements that were not imputed): 
* \eqn{RMSE = \sqrt{\sum_i (true_i - est_i)^2 / \#NAs)}};
* \eqn{MAE = \sum_i |true_i - est_i| / \#NAs};
* \eqn{MAPE = \dfrac{100}{n} \sum_i |true_i - est_i / true_i|} 
(here we omit the true beta-values equal to 0 and their  predicted values
to  avoid an indeterminate measure);
* \eqn{PCC = \dfrac{\sum_i (true_i - \bar{true_i}) \sum_i(est_i - \bar{est}_i)}{\sqrt{\sum_i (true_i - \bar{true}_i)^2}} \sqrt{\sum_i(est_i - \bar{est_i})^2}}.
}
\examples{
data(beta)
with_missing_data <- generateMissingData(beta, lambda = 3.5)
beta_with_nas <- with_missing_data$beta_with_nas
na_positions <- with_missing_data$na_positions
beta_imputed <- methyLImp2(input = beta_with_nas, type = "EPIC", 
                          minibatch_frac = 0.5,
                          BPPARAM = BiocParallel::SnowParam(workers = 1))
evaluatePerformance(beta, beta_imputed, na_positions)
}
